(defun convert-bl-wgs-84-to-xy-by-property (list-property list-bl-wgs-84 / 
					    a-krassovski b-krassovski a-wgs-84 b-wgs-84 dx dy dz l0
					    list-bl-sk-42 list-datum list-sk list-xyz-sk-42 list-xyz-wgs-84
					    m wx wy wz xy FalseNorthing FalseEasting)
  (setq list-sk  (cdr (nth 0 list-property)))
  (setq list-datum (cdr (nth 1 list-property)))
  (setq a-wgs-84 6378137.000)
  (setq b-wgs-84 6356752.314)
  (setq a-krassovski 6378245.000)
  (setq b-krassovski 6356863.019)
  (setq
    L0 (convert-grad-rad (convert-str-grad-to-deg-grad(cdr(assoc "CMeridian" list-sk))))
    dx (atof(cdr(assoc "DX" list-datum)))
    dy (atof(cdr(assoc "DY" list-datum)))
    dz (atof(cdr(assoc "DZ" list-datum)))
    wx (convert-grad-rad(/ (atof(cdr(assoc "Rx" list-datum))) 3600.0))
    wy (convert-grad-rad(/ (atof(cdr(assoc "Ry" list-datum))) 3600.0))
    wz (convert-grad-rad(/ (atof(cdr(assoc "Rz" list-datum))) 3600.0))
    m (/(atof(cdr(assoc "scale" list-datum)))1000000.0)
    FalseNorthing (atof(cdr(assoc "FalseNorthing" list-sk)))
    FalseEasting (atof(cdr(assoc "FalseEasting" list-sk)))
    )
  (setq list-XYZ-wgs-84(calculation-XYZ-by-BLH list-bl-wgs-84 a-wgs-84 b-wgs-84))
  (setq list-XYZ-sk-42(transform-xyz-be-7-property
			(* dx -1.0) (* dy -1.0) (* dz -1.0)
			(* wx -1.0) (* wy -1.0) (* wz -1.0)
			(* m -1.0)
			(nth 0 list-XYZ-wgs-84)
			(nth 1 list-XYZ-wgs-84)
			(nth 2 list-XYZ-wgs-84)))
  (setq list-bl-sk-42 (calculation-BLH-by-XYZ list-XYZ-sk-42 a-krassovski b-krassovski))
  (princ(setq xy (calculation-bl-to-xy-gaus (convert-grad-rad(nth 0 list-bl-sk-42)) (convert-grad-rad(nth 1 list-bl-sk-42)) L0 a-krassovski b-krassovski)))
  (list (+(nth 0 xy)FalseEasting) (+(nth 1 xy)FalseNorthing))
  )