(defun C:export_to_kml (/ a-krassovski a-wgs-84 b-krassovski b-wgs-84 dx dy dz l0 list-bl-sk-42 m wx wy wz x y list-bl-wgs-84 list-xyz-sk-42 list-xyz-wgs-84)
  (setq a-wgs-84 6378137.000)
  (setq b-wgs-84 6356752.314)
  (setq a-krassovski 6378245.000);298.3000031662
  (setq b-krassovski 6356863.019)
  (setq
    x 5713013.92
    y (- 573344.19 500000.0)
    L0 (convert-grad-rad 45.0)
    )
  (setq
    dx 26.3
    dy -132.6
    dz -76.3
    wx (convert-grad-rad(/ -0.22 3600.0))
    wy (convert-grad-rad(/ -0.40 3600.0))
    wz (convert-grad-rad(/ -0.90 3600.0))
    m -0.12e-6)
  (setq list-bl-sk-42(calculation-xy-gaus-to-bl x y L0 a-krassovski b-krassovski))
  (setq list-XYZ-sk-42(calculation-XYZ-by-BLH (list (convert-rad-grad(nth 0 list-bl-sk-42)) (convert-rad-grad(nth 1 list-bl-sk-42))) a-krassovski b-krassovski))
  (setq list-XYZ-wgs-84(transform-xyz-be-7-property dx dy dz wx wy wz m (nth 0 list-XYZ-sk-42)(nth 1 list-XYZ-sk-42)(nth 2 list-XYZ-sk-42)))
  (setq list-bl-wgs-84 (calculation-BLH-by-XYZ (list (nth 0 list-XYZ-wgs-84) (nth 1 list-XYZ-wgs-84) (nth 2 list-XYZ-wgs-84)) a-wgs-84 b-wgs-84))
  (princ (strcat
	   "\nB_42="(rtos(convert-rad-grad(nth 0 list-bl-sk-42))2 16)
	   "\nL_42="(rtos(convert-rad-grad(nth 1 list-bl-sk-42))2 16)
	   "\nDB_42="(rtos(-(convert-rad-grad(nth 0 list-bl-sk-42))51.541987313848)2 16)
	   "\nDL_42="(rtos(-(convert-rad-grad(nth 1 list-bl-sk-42))46.057183721802)2 16)
	   "\nB_42="(calculation_dec_to_gms(convert-rad-grad(nth 0 list-bl-sk-42)))
	   "\nL_42="(calculation_dec_to_gms(convert-rad-grad(nth 1 list-bl-sk-42)))))
  (princ (strcat
	   "\nX_42="(rtos(nth 0 list-XYZ-sk-42)2 5)
	   "\nY_42="(rtos(nth 1 list-XYZ-sk-42)2 5)
	   "\nZ_42="(rtos(nth 2 list-XYZ-sk-42)2 5)
	   "\nX_wgs-84="(rtos(nth 0 list-XYZ-wgs-84)2 5)
	   "\nY_wgs-84="(rtos(nth 1 list-XYZ-wgs-84)2 5)
	   "\nZ_wgs-84="(rtos(nth 2 list-XYZ-wgs-84)2 5)))
  (princ (strcat
	   "\nwx="(rtos wx 1 5)
	   "\nwy="(rtos wy 1 5)
	   "\nwz="(rtos wz 1 5)
	   ))
  (princ (strcat
	   "\nB_wgs-84="(rtos(nth 0 list-bl-wgs-84)2 16)
	   "\nL_wgs-84="(rtos(nth 1 list-bl-wgs-84)2 16)
	   "\nDB_wgs-84="(rtos(-(nth 0 list-bl-wgs-84)51.542094982135)2 16)
	   "\nDL_wgs-84="(rtos(-(nth 1 list-bl-wgs-84)46.055681340081)2 16)
	   "\nB_wgs-84="(calculation_dec_to_gms(nth 0 list-bl-wgs-84))
	   "\nL_wgs-84="(calculation_dec_to_gms(nth 1 list-bl-wgs-84))))
  (princ)
  )

;|

sk-42
x=5713013.92
y=8573344.19



sk-42
b=5132'31,15432985"
l=4603'25,86139849"
51.541987313848
46.057183721802

wgs-84
b=5132'31,54193569"
l=4603'20,45282429"
51.542094982135
46.055681340081


B_42=51.541987311
L_42=46.057183722

B_42=51d32'31.1543"
L_42=46d3'25.8614"

B_wgs-84=51.542036124
L_wgs-84=46.055556272

B_wgs-84=51d32'31.3300"
L_wgs-84=46d3'20.0026"

sk-42
51,541987313848
46,057183721802

wgs-84
51,542094982135
46,055681340081

|;

